/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');
var ShiftWorkday = require('./ShiftWorkday');
var TimeRange = require('./TimeRange');




/**
 * The ShiftFilter model module.
 * @module model/ShiftFilter
 */

/**
 * Constructs a new <code>ShiftFilter</code>.
 * Defines a filter used in a search for &#x60;Shift&#x60; records. &#x60;AND&#x60; logic is used by Square&#39;s servers to apply each filter property specified.
 * @alias module:model/ShiftFilter
 * @class
 */
var exports = function() {
  var _this = this;







};

/**
 * Constructs a <code>ShiftFilter</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/ShiftFilter} obj Optional instance to populate.
 * @return {module:model/ShiftFilter} The populated <code>ShiftFilter</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('location_id')) {
      obj['location_id'] = ApiClient.convertToType(data['location_id'], ['String']);
    }
      if (data.hasOwnProperty('employee_id')) {
      obj['employee_id'] = ApiClient.convertToType(data['employee_id'], ['String']);
    }
      if (data.hasOwnProperty('status')) {
      obj['status'] = ApiClient.convertToType(data['status'], 'String');
    }
      if (data.hasOwnProperty('start')) {
      obj['start'] = TimeRange.constructFromObject(data['start']);
    }
      if (data.hasOwnProperty('end')) {
      obj['end'] = TimeRange.constructFromObject(data['end']);
    }
      if (data.hasOwnProperty('workday')) {
      obj['workday'] = ShiftWorkday.constructFromObject(data['workday']);
    }
    }
  return obj;
}

/**
 * Fetch shifts for the specified location.
 * @member {Array.<String>} location_id
 */
exports.prototype['location_id'] = undefined;
/**
 * Fetch shifts for the specified employee.
 * @member {Array.<String>} employee_id
 */
exports.prototype['employee_id'] = undefined;
/**
 * Fetch a `Shift` instance by `Shift.status`. See [ShiftFilterStatus](#type-shiftfilterstatus) for possible values
 * @member {module:model/ShiftFilter.StatusEnum} status
 */
exports.prototype['status'] = undefined;
/**
 * Fetch `Shift`s that start in the time range - Inclusive.
 * @member {module:model/TimeRange} start
 */
exports.prototype['start'] = undefined;
/**
 * Fetch the `Shift`s that end in the time range - Inclusive.
 * @member {module:model/TimeRange} end
 */
exports.prototype['end'] = undefined;
/**
 * Fetch the `Shift`s based on workday date range.
 * @member {module:model/ShiftWorkday} workday
 */
exports.prototype['workday'] = undefined;


  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "OPEN"
     * @const
     */
    "OPEN": "OPEN",
    /**
     * value: "CLOSED"
     * @const
     */
    "CLOSED": "CLOSED"  };


module.exports = exports;



