/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');




/**
 * The SourceApplication model module.
 * @module model/SourceApplication
 */

/**
 * Constructs a new <code>SourceApplication</code>.
 * Provides information about the application used to generate an inventory change.
 * @alias module:model/SourceApplication
 * @class
 */
var exports = function() {
  var _this = this;




};

/**
 * Constructs a <code>SourceApplication</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/SourceApplication} obj Optional instance to populate.
 * @return {module:model/SourceApplication} The populated <code>SourceApplication</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('product')) {
      obj['product'] = ApiClient.convertToType(data['product'], 'String');
    }
      if (data.hasOwnProperty('application_id')) {
      obj['application_id'] = ApiClient.convertToType(data['application_id'], 'String');
    }
      if (data.hasOwnProperty('name')) {
      obj['name'] = ApiClient.convertToType(data['name'], 'String');
    }
    }
  return obj;
}

/**
 * Read-only [Product](#type-product) type for the application. See [Product](#type-product) for possible values
 * @member {module:model/SourceApplication.ProductEnum} product
 */
exports.prototype['product'] = undefined;
/**
 * Read-only Square ID assigned to the application. Only used for [Product](#type-product) type `EXTERNAL_API`.
 * @member {String} application_id
 */
exports.prototype['application_id'] = undefined;
/**
 * Read-only display name assigned to the application (e.g. `\"Custom Application\"`, `\"Square POS 4.74 for Android\"`).
 * @member {String} name
 */
exports.prototype['name'] = undefined;


  /**
   * Allowed values for the <code>product</code> property.
   * @enum {String}
   * @readonly
   */
  exports.ProductEnum = {
    /**
     * value: "SQUARE_POS"
     * @const
     */
    "SQUARE_POS": "SQUARE_POS",
    /**
     * value: "EXTERNAL_API"
     * @const
     */
    "EXTERNAL_API": "EXTERNAL_API",
    /**
     * value: "BILLING"
     * @const
     */
    "BILLING": "BILLING",
    /**
     * value: "APPOINTMENTS"
     * @const
     */
    "APPOINTMENTS": "APPOINTMENTS",
    /**
     * value: "INVOICES"
     * @const
     */
    "INVOICES": "INVOICES",
    /**
     * value: "ONLINE_STORE"
     * @const
     */
    "ONLINE_STORE": "ONLINE_STORE",
    /**
     * value: "PAYROLL"
     * @const
     */
    "PAYROLL": "PAYROLL",
    /**
     * value: "DASHBOARD"
     * @const
     */
    "DASHBOARD": "DASHBOARD",
    /**
     * value: "ITEM_LIBRARY_IMPORT"
     * @const
     */
    "ITEM_LIBRARY_IMPORT": "ITEM_LIBRARY_IMPORT",
    /**
     * value: "OTHER"
     * @const
     */
    "OTHER": "OTHER"  };


module.exports = exports;



